/*
 * acqthread.cpp
 *
 *	17.08.04 - GG: first release 
 */


#include "acqthread.h"

/* 
 * acqthread::run()
 * Run  
 */		
void *acqthread::run_undetached(void *) 
{
	int margin = 2;
	double frequency = 50;
	int32_t old_bn = 0;
	Tango::DevLong bunch_number;

	try {
		if (myobj->bn_device) {
			myobj->bn_device->read_attribute(myobj->bn_attr_name) >> bunch_number;
			old_bn = bunch_number - frequency + 1;	
		}
	}
	catch(...){}

	while (myobj->abort_flag == false) {
		if (*myobj->attr_EnablePolling_read) {
			try {
				myobj->mutex->lock();
				if (myobj->bn_device) {
					myobj->bn_device->read_attribute(myobj->bn_attr_name) >> bunch_number;
					int32_t bn_start = myobj->last_bn + 1;
					int32_t bn_end = bunch_number - margin;
					if ((bn_end - bn_start) > frequency)
						bn_start = bn_end - frequency + 1;
					myobj->store_circ_data(1, 0, bn_start, bn_end);										
				}
				else {
					// last mode, bn_start/bn_end equal to 0
					myobj->store_circ_data(0, *myobj->attr_PollingSamples_read, 0, 0);
				}	
				myobj->mutex->unlock();			
				usleep(*myobj->attr_PollingPeriod_read * 1000);
			}
			// sleep on error
			catch(...) { myobj->mutex->unlock();sleep(1);}	
		
		}
		// sleep when polling disabled
		else {
			sleep(1);
		}

	}

	myobj->abort_flag = false;

} /* end acqthread::run() */	
	

